#pragma once
//*****************************************************************************************************
//  1. t@C
//		ManualEditDocument.h
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CManualEditDocument NX̃C^[tFCX
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************

// Ot
#define GRAPH_KOTEI			0		// H\
#define GRAPH_YOSO_SAGYOGUN	1		// vfƌQ\

// OtXV
#define UPDATE_GRAPH_UPDATE	0		// f[^XV
#define UPDATE_GRAPH_KISHU	1		// @ύX
#define UPDATE_GRAPH_KIND	2		// ʕύX
#define UPDATE_SCROLL		3		// XN[
#define UPDATE_CHANGE_SLIM	4		// X\ύX
#define UPDATE_CHANGE_SUBLINE	5	// TuCύX
#define UPDATE_EDIT_VIEW	6		// ҏWr[XV
#define UPDATE_SELECT_BLINK	7		// Ig_
#define UPDATE_ERASE_MOVE_TRIANGLE	8	// ړ}[NiOpj
#define UPDATE_SCROLL_ACTIVE	13	// XN[(ANeBuʂ̂)

// OtubNiϏグo[̎lp`jf[^
struct SGraphBlock {
	int nSublineId;					// TuCID
	int nKishuId;					// @ID
	CString sKoteiName;				// H
	CString sYosoSagyogunName;		// vfƌQ
	CString sJido;					// H
	double fTime;					// Ǝ
	BOOL bKyotsuKotei;				// ʍHtO
	int nGroupNo;					// O[vԍ
	BOOL bKitting;					// LbgƃtO
	CIntArrayEx aYosoSagyogunId;	// vfƌQIDz
	BOOL bNewMove;					// ŐVړtO
	BOOL bKittingCancel;			// LbgtO
};
typedef CArrayEx <SGraphBlock, SGraphBlock&> CGraphBlockArray;
typedef CArrayEx <SGraphBlock *, SGraphBlock *> CGraphBlockPtrArray;

// Ot̋@ʃf[^
struct SGraphKishu {
	CString sKishuName;				// @햼
	double fTime;
};
typedef CArrayEx <SGraphKishu, SGraphKishu&> CGraphKishuArray;

// Ot̍Ǝҕʃf[^
struct SGraphSagyosha {
	CString sSagyoshaName;			// ƎҖ
	CString sSagyoshaDispName;		// Ǝҕ\p
	CGraphKishuArray aKishu;		// @f[^z
	CGraphBlockArray aYosoSagyogun;	// vfƌQf[^z
	CGraphBlockArray aKotei;		// Hf[^z
	double fTime;					// Ǝ
	int nSagyoshaId;				// ƎID
	BOOL bKitting;					// LbgƃtO
};
typedef CArrayEx2 <SGraphSagyosha, SGraphSagyosha&> CGraphSagyoshaArray;

// TuCʂ̃f[^
struct SGraphSubline {
	int nSublineId;					// TuCIDiLbgƂ-1j
	CString sSublineName;			// TuC
	CGraphSagyoshaArray aGraphSagyosha;	// ƎҕʃOtf[^z
	double fMokugyoTact;			// ڕW^Ng
	double fJogen;					// 
	double fKagen;					// 
	double fKadoRitsu;				// ғ
};
typedef CArrayEx <SGraphSubline, SGraphSubline&> CGraphSublineArray;

// hbOWf[^
struct SZahyoDrag {
	CRect rect;					// W
	SGraphBlock *pGraphBlock;	// ubNf[^ւ̃|C^
	int nSagyoshaId;			// ƎID
	int nIndex;
};
typedef CArrayEx <SZahyoDrag, SZahyoDrag&> CZahyoDragArray;

// hbvWf[^
struct SZahyoDrop {
	CRect rect;					// W
	CPoint pointTriangle;		// Op`\W
	SGraphBlock *pGraphBlock;	// ubNf[^ւ̃|C^
	int nSagyoshaId;			// ƎID
	int nIndex;
	BOOL bLastBlock;
};
typedef CArrayEx <SZahyoDrop, SZahyoDrop&> CZahyoDropArray;

// ƎҖ̍W
struct SZahyoSagyosha {
	CRect rect;
	int nSublineId;
	int nSagyoshaId;
};
typedef CArrayEx <SZahyoSagyosha, SZahyoSagyosha&> CZahyoSagyoshaArray;

// IƎ
struct SSelectSagyosha {
	BOOL bSelect;
	int nSubnlineId;
	int nSagyoshaId;

	SSelectSagyosha() {
		bSelect = FALSE;
	}
};

// IH
struct SSelectYosoSagyogun {
	int		nIndex;				// OtID(@했̃CfbNX)
	int		nIndexKishu;			// @했Index
	int		nSublineId;			// TuCID
	int		nKishuId;			// @ID
	int		nSagyoshaId;		// ƎID
	CString	sKoteiName;			// H
	CString	sYosoSagyogunName;	// vfƌQ
	BOOL	bKyotsuKotei;		// ʍHtO
	int		nGroupNo;			// ʍHO[vԍ
	BOOL	bKitting;			// LbgƃtO
};
typedef CArrayEx <SSelectYosoSagyogun, SSelectYosoSagyogun&> CSelectYosoSagyogunArray;

// QƍH
struct SReferenceYosoSagyogun {
	int		nIndex;				// OtID(@했̃CfbNX)
	int		nIndexKishu;			// @했Index
	int		nSublineId;			// TuCID
	int		nKishuId;			// @ID
	int		nSagyoshaId;		// ƎID
	CString	sKoteiName;			// H
	CString	sYosoSagyogunName;	// vfƌQ
};
typedef CArrayEx <SReferenceYosoSagyogun, SReferenceYosoSagyogun&> CReferenceYosoSagyogunArray;

// 蓮ҐhLg
class CManualEditDocument : public CDocument
{
protected:
	CManualEditDocument();           // IɎgpveNg RXgN^B
	DECLARE_DYNCREATE(CManualEditDocument)

// Agr[g
public:

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CManualEditDocument)
	//}}AFX_VIRTUAL

// Cve[V
public:
	CGraphSublineArray m_aGraphSubline;		// TuCʃf[^z
// Modify ... ( DELETE )
//	int m_nGraphKishu;				// \̋@
// By Y.Itabashi (xxxxx) 2007.02.26
	int m_nGraphKind;				// \̃Ot
	BOOL m_bSlimMode;				// X[htO
	SZahyoDrop *m_pDrop;			// hbvWf[^
	int m_nTotalSeisanDaisu;		// S@̐Y䐔̍v
	int m_nKittingIndex;			// LbgƂ̃CfbNX
	SSelectSagyosha m_cSelectSagyosha;	// IƎ
// Modify ... ( CHANGE )
//	CIntArrayEx m_aSelectedBox;		// I
	CSelectYosoSagyogunArray m_aSelectYosoSagyogun;		// I
	CReferenceYosoSagyogunArray m_aRefYosoSagyogun;		// Qƍ
	CFrameWnd *m_pSelectWnd;			// ƂIꂽ
	CFrameWnd *m_pDragWnd;				// hbOꂽ
// By Y.Itabashi (xxxxx) 2007.02.27
	BOOL m_bSelectKitting;			// LbgƑI𒆃tO
	BOOL m_bDispNewMove;			// ŐVړ\tO
	int m_nDropSublineId;			// hbvꏊ̃TuCGA

// Modify ... ( CHANGE )
	void ChangeGraphKishu(int nGraphKishu, CFrameWnd *pWnd);
//	void ChangeGraphKishu(int nGraphKishu);
// By Y.Itabashi (xxxxx) 2007.02.27
	void ChangeGraphKind(int nGraphKind);
	void MakeGraphData();
	void UpdateGraph(BOOL bSetSagyojun);
	void DispCenterSagyosha(int nSublineId, int nSagyoshaId);
	void StopBlink(BOOL bStopBlink);
	SGraphSubline *GetGraphSublineData(int nSublineId);
	void MoveItem(int nSublineIdFrom, CGraphBlockPtrArray &aGraphBlockFrom, int nSublineIdTo, SGraphBlock *pGraphBlockTo, int nSagyoshaId, BOOL bLastBlock);
	void MoveItem1(int nSublineId, CGraphBlockPtrArray &aGraphBlockFrom, SGraphBlock *pGraphBlockTo, int nSagyoshaId, BOOL bLastBlock);
	void MoveItem1Sub(int nSublineId, int nYosoSagyogunIdFrom, int nKishuIdFrom, int nYosoSagyogunIdTo, int nKishuIdTo, int nSagyoshaId, BOOL bLastBlock);
	void MoveItem2(int nSublineIdFrom, CGraphBlockPtrArray &aGraphBlockFrom, int nSublineIdTo, SGraphBlock *pGraphBlockTo, int nSagyoshaId, BOOL bLastBlock);
	SGraphBlock *GetFirstGraphBlock(int nSublineId);
	SGraphBlock *GetNextGraphBlock(int nSublineId, int nSagyoshaId);
// Modify ... ( ADD )
	BOOL CheckSameKoteiMove( SGraphBlock *pGraphBlockFrom, SGraphBlock *pGraphBlockTo, BOOL bLastBlock );
// By Y.Itabashi (xxxxx) 2007.02.10
// Modify ... ( ADD )
	void AddSelectKotei( SZahyoDrag sZahyoDrag, int nGraphKishu );
	void AddReferenceKotei( SZahyoDrag sZahyoDrag, int nGraphKishu );
	void AddSelectKoteiOtherWindow();
// By Y.Itabashi (xxxxx) 2007.02.27
// Modify ... ( ADD )
	void CancelReferenceYosoSagyogun( CString sKoteiName, CString sYosoSagyogunName );
	void InitReferenceYosoSagyogun();
// By Y.Itabashi (xxxxx) 2007.03.06
// Modify ... ( ADD )
	void AddSelectAutoKotei();
// By Y.Itabashi (xxxxx) 2007.03.07

	// bZ[W }bv֐̐
protected:
	//{{AFX_MSG(CManualEditDocument)
	afx_msg void OnRadioGraphKotei();
	afx_msg void OnRadioGraphYosoSagyogun();
	afx_msg void OnWindowViewType();
	afx_msg void OnHelpVersion();
	afx_msg void OnViewSlimGraph();
	afx_msg void OnUpdateViewSlimGraph(CCmdUI* pCmdUI);
	afx_msg void OnViewSelectSubline();
	afx_msg void OnToolKittingSet();
	afx_msg void OnToolLineKisei();
	afx_msg void OnToolKatashikiKisei();
	afx_msg void OnToolKyotsuKotei();
	afx_msg void OnUpdateToolLineKisei(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolKatashikiKisei(CCmdUI* pCmdUI);
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnEditRedo();
	afx_msg void OnUpdateEditRedo(CCmdUI* pCmdUI);
	afx_msg void OnWindowSeiretsu();
	afx_msg void OnFileExport();
	afx_msg void OnUpdateToolKittingSet(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void MakeGraphDataSubline(int nSublineId);
	void MakeGraphDataKitting();
	void SetWindowTitle();
// Modify ... ( ADD )
	BOOL CheckSelectKishu( int nKishuId );
	void GetGraphIndex( int nIndex, int nGraphKishu, int nKishuId, int &nIndexAll, int &nIndexKishu );
// By Y.Itabashi (xxxxx) 2007.02.27
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B
